c.....Bubble correction: finite part.           
c.....musq = mu^2 is an external scale
c 
c.....int d^dk/(2 pi)^d 1/(k^2)/(k+p1)^2 = 
c          N_ep * B0fin(p1sq,musq)
c          N_ep = i/(4 pi)^2 (4 pi)^ep Gamma(1+ep) (musq)^(-ep)
c
c.....ris(1) = finite part
c.....ris(2) = coeff of 1/ep
c.....ris(3) = coeff of 1/ep^2      

      function B0fin(p1sq,musq)
      implicit none
      complex * 16 B0fin
      real * 8 p1sq,musq
      complex * 16 ris(3)
      complex * 16 l1
      complex * 16 I
      parameter (I=(0,1))
      double precision pi
      parameter (pi=3.141592653589793238462643383279502884197D0)
      complex * 16 ipi
      parameter (ipi=(0,3.141592653589793238462643383279502884197D0))
      integer j,offshellleg

      real * 8 tiny
      parameter (tiny=1d-7)

      if (musq.lt.0) then
         write(*,*) "ERROR in B0fin: mu^2 MUST be a positive number"
         stop
      endif

      if (abs(p1sq).lt.tiny) then
c     BUBBLE WITH ZERO EXTERNAL INVARIANTS
c      write(*,*) "Warning: B0fin called with external"//
c     #       " invariant equal to zero"
         ris(3) = 0.d0
         ris(2) = 0.d0
         ris(1) = 0.d0
         B0fin = ris(1)
         return
      endif
      l1 =  log(abs(p1sq/musq))
      if (p1sq.gt.0) then
         l1 = l1 -ipi
      endif
      ris(3) = 0d0
      ris(2) = 1d0
      ris(1) = 2-l1
      B0fin = ris(1)
      end
